<?php


namespace TDevAgency\Cms\Commands;


use Illuminate\Console\Command;
use Illuminate\Support\Facades\File;


class PublicAssets extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'cms:assets';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Set symlink to assets';

    /**
     * Execute the console command.
     *
     * @return mixed
     * @throws \Illuminate\Contracts\Container\BindingResolutionException
     */
    public function handle()
    {
        if (!file_exists(public_path('ckeditor'))) {
            if ($this->laravel->make('files')->exists(TDEV_AGENCY_CMS_ROOT . 'public' . DIRECTORY_SEPARATOR . 'ckeditor')) {
                $this->laravel->make('files')->link(
                    TDEV_AGENCY_CMS_ROOT . 'public' . DIRECTORY_SEPARATOR . 'ckeditor',
                    public_path('ckeditor')
                );
            }
        }
        if (file_exists(public_path('cms'))) {
            File::cleanDirectory(public_path('cms'));
            $this->laravel->make('files')->deleteDirectory(public_path('cms'));
        }

        $this->laravel->make('files')->makeDirectory(public_path('cms'));

        if ($this->laravel->make('files')->exists(TDEV_AGENCY_CMS_ROOT . 'public' . DIRECTORY_SEPARATOR . 'js')) {
            $this->laravel->make('files')->link(
                TDEV_AGENCY_CMS_ROOT . 'public' . DIRECTORY_SEPARATOR . 'js',
                public_path('cms/js')
            );
        }
        if ($this->laravel->make('files')->exists(TDEV_AGENCY_CMS_ROOT . 'public' . DIRECTORY_SEPARATOR . 'css')) {
            $this->laravel->make('files')->link(
                TDEV_AGENCY_CMS_ROOT . 'public' . DIRECTORY_SEPARATOR . 'css',
                public_path('cms/css')
            );
        }
        if ($this->laravel->make('files')->exists(TDEV_AGENCY_CMS_ROOT . 'public' . DIRECTORY_SEPARATOR . 'cms' . DIRECTORY_SEPARATOR . 'fonts')) {
            $this->laravel->make('files')->link(
                TDEV_AGENCY_CMS_ROOT . 'public' . DIRECTORY_SEPARATOR . 'cms' . DIRECTORY_SEPARATOR . 'fonts',
                public_path('cms/fonts')
            );
        }
        if ($this->laravel->make('files')->exists(TDEV_AGENCY_CMS_ROOT . 'public' . DIRECTORY_SEPARATOR . 'cms' . DIRECTORY_SEPARATOR . 'images')) {
            $this->laravel->make('files')->link(
                TDEV_AGENCY_CMS_ROOT . 'public' . DIRECTORY_SEPARATOR . 'cms' . DIRECTORY_SEPARATOR . 'images',
                public_path('cms/images')
            );
        }


        $this->info('The [public/cms] directory has been linked.');
    }
}
